<template>
<div class="cover">
	<img class="ctrls" src="assets/gui/controls_screen/controls_screen.png" />
</div>
</template>

<script>
import Vue from "vue"

import { FLOOR_MAP_CITADEL } from "../../constants/tower.js"
import {
	DEFAULT_BODY,
	DEFAULT_WHEEL
} from "../../constants/car.js"

export default {
	data () {
		return {
			start: true
		}
	},
	methods: {
		loop () {
			Vue.nextTick(() => {
				const start = Input.list[0].get(CONTROLS.MENU_START)

				const skins = [
					"BODY_BASE_RED",
					"BODY_BASE_BLUE",
					"BODY_WOAH_RED",
					"BODY_WOAH_BLUE"
				]

				if (start && !this.start) {
					Tower.goToFloor(FLOOR_MAP_CITADEL, "down", undefined, null)
					const players = window.playerSettings.map((player, index) => {
							return {
								ai: false,
								alignment: index % 2 === 0 ? "RED" : "BLUE",
								body: skins[index],
								control: Input.list[index].getID(),
								name: `P${index + 1}`,
								ultimates: [player.ultimate_1, player.ultimate_2, player.ultimate_3],
								wheel: DEFAULT_WHEEL,
							}
						})
					const length = players.length
					while (players.length < 4) {
						players.push({
							ai: true,
							alignment: (players.length - length) % 2 === 0 ? "BLUE" : "RED",
							body: skins[players.length - length + 1],
							name: `AI ${players.length - length + 1}`,
							ultimates: ["ULTIMATE_ANTI_ENERGY", "ULTIMATE_OVERCHARGE"],
							wheel: DEFAULT_WHEEL
						})
					}
					StateManager.change(States.LocalGame, [{
						map: Maps.default,
						players: players
					}])
				} else {
					window.setTimeout(() => {
						this.loop()
					}, 1)
				}
				this.start = start
			})
		}
	},
	mounted () {
		this.loop()
	},
	name: "rtx-controls"
}
</script>

<style>
.cover {
	align-items: center;
	bottom: 0;
	display: flex;
	justify-content: center;
	left: 0;
	position: absolute;
	right: 0;
	top: 0;
}

.ctrls {
	width: 100%;
}
</style>
